Index: c/src/lib/libbsp/powerpc/mvme5500/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/ChangeLog	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/ChangeLog	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,2 +1,38 @@
+2009-04-20	Kate Feng <feng1@bnl.gov>
+
+	1396/bsps
+	* pci/pci.c : Updated it to be consistent with the original pci.c
+	* written by Eric Valette.  There is no change in its function.
+	* irq/irq_init.c : set defaultIrq->next_handler to be 0 
+	* for BSP_SHARED_HANDLER_SUPPORT.
+	* network/if_1GHz/if_wm.c : fixed some bugs in the 1GHz driver.
+	* irq/BSP_irq.c : added supports for shared IRQ.
+	* pci/pci_interface.c : Enabled PCI "Read", "Read Line", and
+	"Read Multiple"
+	*  Agressive Prefetch to improve the performance of the PCI based
+	*  applications (e.g. 1GHz NIC).
+	* irq/BSP_irq.c : Replaced the irq/irq.c, and used GT_GPP_Value
+	* register to monitor the cause of the level sensitive interrupts.
+	* This unique solution solves various bugs in the 1GHz network drivers
+	* Fixed bugs in compute_pic_masks_from_prio()
+
+2009-04-20	Kate Feng <feng1@bnl.gov>
+
+	1396/bsps
+	* pci/pci.c : Updated it to be consistent with the original pci.c
+	* written by Eric Valette.  There is no change in its function.
+	* irq/irq_init.c : set defaultIrq->next_handler to be 0 
+	* for BSP_SHARED_HANDLER_SUPPORT.
+	* network/if_1GHz/if_wm.c : fixed some bugs in the 1GHz driver.
+	* irq/BSP_irq.c : added supports for shared IRQ.
+	* pci/pci_interface.c : Enabled PCI "Read", "Read Line", and
+	"Read Multiple"
+	*  Agressive Prefetch to improve the performance of the PCI based
+	*  applications (e.g. 1GHz NIC).
+	* irq/BSP_irq.c : Replaced the irq/irq.c, and used GT_GPP_Value
+	* register to monitor the cause of the level sensitive interrupts.
+	* This unique solution solves various bugs in the 1GHz network drivers
+	* Fixed bugs in compute_pic_masks_from_prio()
+	
 2007-11-30	Joel Sherrill <joel.sherrill@OARcorp.com>
 
@@ -7,5 +43,5 @@
 
 	* network/if_100MHz/GT64260eth.c: Add else.
-
+   
 2007-09-19	Kate Feng <feng1@bnl.gov>
 
Index: c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,6 +1,7 @@
 /* GT64260TWSI.c : Two-Wire Serial Interface (TWSI) support for the GT64260
  *
- * Copyright (c) 2004, Brookhaven National Laboratory and
- *                 Shuchen Kate Feng <feng1@bnl.gov>
+ * Copyright (c) 2004, Brookhaven National Laboratory
+ *               and Shuchen Kate Feng <feng1@bnl.gov>
+ *               under the Deaprtment of Energy contract DE-AC02-98CH10886
  * All rights reserved.
  *
Index: c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/GT64260/GT64260TWSI.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,4 +1,8 @@
 /*
  *  $Id$
+ * 
+ *  Copyright 2003  S. Kate Feng <feng1@bnl.gov>,
+ *            NSLS, Brookhaven National Laboratory. All rights reserved.
+ *            under the Deaprtment of Energy contract DE-AC02-98CH10886
  */
 
Index: c/src/lib/libbsp/powerpc/mvme5500/GT64260/MVME5500I2C.c
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/GT64260/MVME5500I2C.c	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/GT64260/MVME5500I2C.c	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -3,4 +3,5 @@
  * Copyright (c) 2003, 2004 Brookhaven National Laboratory
  * Author:    S. Kate Feng <feng1@bnl.gov>
+ *            under the Deaprtment of Energy contract DE-AC02-98CH10886
  * All rights reserved.
  *
@@ -30,7 +31,8 @@
 * I2Cread_eeprom - read EEPROM VPD from the I2C
 */
-int I2Cread_eeprom(unchar I2cBusAddr,u32 devA2A1A0,u32 AddrBytes,unchar *pBuff,u32 numBytes)
+int I2Cread_eeprom(unchar I2cBusAddr,u32 devA2A1A0,u32 AddrBytes,void *pBuff,u32 numBytes)
 {
   int status=0, lastByte=0;
+  unchar *ptr=(unchar *) pBuff;
 
   switch (AddrBytes) {
@@ -84,10 +86,13 @@
      for ( ; numBytes > 0; numBytes-- ) {      
        if ( numBytes == 1) lastByte=1;
-       if (GT64260TWSIread(pBuff,lastByte) == -1) return (-1);
+       if (GT64260TWSIread(ptr,lastByte) == -1) {
+	 printk("numBytes %d\n", numBytes);
+          return (-1);
+       }
 #ifdef I2C_DEBUG
-       printk("%2x ", *pBuff);
+       printk("%2x ", *ptr);
        if ( (numBytes % 20)==0 ) printk("\n");
 #endif
-       pBuff++;	
+       ptr++;	
      }
 #ifdef I2C_DEBUG
Index: c/src/lib/libbsp/powerpc/mvme5500/GT64260/VPD.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/GT64260/VPD.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/GT64260/VPD.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -3,9 +3,73 @@
  * (C) 2004, NSLS, Brookhaven National Laboratory,
  *           S. Kate Feng, <feng1@bnl.gov>
- *
+ *  under the Deaprtment of Energy contract DE-AC02-98CH10886
  */
 
 extern unsigned char ConfVPD_buff[200];
 
-#define VPD_ENET0_OFFSET  0x3c
-#define VPD_ENET1_OFFSET  0x45
+typedef struct ConfVpdRec {
+  char VendorId[8];
+  char pad0[4];
+  char BrdId[13];
+  char pad1[2];
+  char ManAssmNum[12];
+  char pad2[2];
+  char SerialNum[7];
+  char pad3[2];
+  /*  char IntClk[4];*/
+  uint32_t IntClk;
+  char pad4[3];
+  /*char ExtClk[4];*/
+  uint32_t ExtClk;
+  char pad5[3];
+  char EnetAddr0[7];
+  char pad6[2];
+  char EnetAddr1[7];
+  char pad7[20];
+} ConfVpdRec_t;
+
+#define VPD_BOARD_ID   8
+#define VPD_ENET0_OFFSET  0x40
+#define VPD_ENET1_OFFSET  0x49
+
+/*
+4D4F544F 524F4C41 0200010D 4D564D45  MOTOROLA....MVME
+35353030 2D303136 33020C30 312D5733  5500-0163..01-W3
+38323946 30314403 07373035 31383238  829F01D..7051828
+05053B9A CA000106 0507F281 55010807  ..;.........U...
+ethernet address
+xxxxxxxx xxxxxxxx xxxxxxxx xxxx3701  ................
+09043734 35350A04 87A6E98C 0B0C0089  ..7455..."=.....
+00181002 02101000 78070B0C FFFFFFFF  ........x.......
+10020210 10017805 0E0FFFFF FFFFFFFF  ......x.........
+FFFFFF01 FF01FFFF FF0F0400 03000019  ................
+0A010107 02030000 000100FF FFFFFFFF  ................
+FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF  ................
+FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF  ................
+00000000 00000000 00000000 00000000  ................
+00000000 00000000 00000000 00000000  ................
+00000000 00000000 00000000 00000000  ................
+00000000 00000000 00000000 00000000  ................
+
+For the MVME5500 :
+
+Product Identifier                 : MVME5500-0163
+Manufacturing Assembly Number      : 01-W3829F01D
+Serial Number                      : 7051828
+Internal Clock Speed (Hertz)       : 3B9ACA00 (&1000000000)
+External Clock Speed (Hertz)       : 07F28155 (&133333333)
+Ethernet Address                   : xx xx xx xx xx xx xx
+Ethernet Address                   : xx xx xx xx xx xx xx
+Microprocessor Type                : 7455
+SROM/EEPROM CRC                    : D3223DD0 (&-752730672)
+Flash0 Memory Configuration        : 00 89 00 18 10 02 02 10
+                                   : 10 00 78 07
+Flash1 Memory Configuration        : FF FF FF FF 10 02 02 10
+                                   : 10 01 78 05
+L2 Cache Configuration             : FF FF FF FF FF FF FF FF
+                                   : FF 01 FF 01 FF FF FF
+VPD Revision                       : 00 03 00 00
+L3 Cache Configuration             : 01 01 07 02 03 00 00 00
+                                   : 01 00
+                                                                               
+*/
Index: c/src/lib/libbsp/powerpc/mvme5500/GT64260/gtreg.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/GT64260/gtreg.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/GT64260/gtreg.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -191,5 +191,5 @@
 #define GT_MPP_Control3			0xf00c
 
-/* <skf> added */
+/* <skf> added for GT64260 */
 #define GT_MPP_SerialPortMultiplex      0xf010
 
@@ -791,11 +791,23 @@
 
 /* Interrupt Controller - Interrupt Controller Registers */
+/* <skf> added for GT64360 */
+
+#define GT64360_MAIN_INT_CAUSE_LO	0x004 /* read Only */
+#define GT64360_MAIN_INT_CAUSE_HI       0x00c /* read Only */
+#define GT64360_CPU0_INT_MASK_LO 	0x014
+#define GT64360_CPU0_INT_MASK_HI	0x01c
+#define GT64360_CPU0_SEL_CAUSE	        0x024 /* read Only */
+
+#define GT64360_CPU1_INT_MASK_LO 	0x034
+#define GT64360_CPU1_INT_MASK_HI	0x03c
+#define GT64360_CPU1_SEL_CAUSE	        0x044 /* read Only */
+
 /* Section 25.2 : Table 734 <skf> */
 
-#define GT_MAIN_INT_CAUSE_LO	0xc18 /* read Only */
-#define GT_MAIN_INT_CAUSE_HI   0xc68 /* read Only */
-#define GT_CPU_INT_MASK_LO 	0xc1c
-#define GT_CPU_INT_MASK_HI	0xc6c
-#define GT_CPU_SEL_CAUSE	0xc70 /* read Only */
+#define GT64260_MAIN_INT_CAUSE_LO	0xc18 /* read Only */
+#define GT64260_MAIN_INT_CAUSE_HI       0xc68 /* read Only */
+#define GT64260_CPU_INT_MASK_LO 	0xc1c
+#define GT64260_CPU_INT_MASK_HI	        0xc6c
+#define GT64260_CPU_SEL_CAUSE	0xc70 /* read Only */
 #define GT_PCI0_INT_MASK_LO	0xc24
 #define GT_PCI0_INT_MASK_HI	0xc64
Index: c/src/lib/libbsp/powerpc/mvme5500/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -36,5 +36,6 @@
     ../../powerpc/shared/startup/sbrk.c ../../shared/bootcard.c \
     startup/bspclean.c ../../shared/bsplibc.c ../../shared/bsppost.c \
-    ../../shared/gnatinstallhandler.c startup/reboot.c
+    ../../shared/gnatinstallhandler.c startup/reboot.c \
+    ../../powerpc/shared/startup/probeMemEnd.c
 startup_rel_CPPFLAGS = $(AM_CPPFLAGS)
 startup_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
@@ -69,6 +70,6 @@
 
 noinst_PROGRAMS += irq.rel
-irq_rel_SOURCES = irq/irq_init.c irq/irq.c \
-    ../../powerpc/shared/irq/irq_asm.S
+irq_rel_SOURCES = irq/irq_init.c irq/BSP_irq.c \
+   ../../powerpc/shared/irq/irq.c ../../powerpc/shared/irq/irq_asm.S
 irq_rel_CPPFLAGS = $(AM_CPPFLAGS)
 irq_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
@@ -109,6 +110,7 @@
 network_CPPFLAGS = -D_KERNEL
 noinst_PROGRAMS += network.rel
-network_rel_SOURCES = network/if_100MHz/GT64260eth.c \
-    network/if_1GHz/if_wm.c network/if_1GHz/pci_map.c
+network_rel_SOURCES = network/if_100MHz/GT64260eth.c network/if_1GHz/if_wm.c \
+	network/if_1GHz/pci_map.c
+
 network_rel_CPPFLAGS = $(AM_CPPFLAGS) $(network_CPPFLAGS)
 network_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
@@ -124,6 +126,6 @@
 noinst_PROGRAMS += vme.rel
 vme_rel_SOURCES = ../../shared/vmeUniverse/vmeUniverse.c\
-	../shared/vme/vmeconfig.c ../../shared/vmeUniverse/bspVmeDmaList.c\
-	../shared/vme/vme_universe.c ../shared/vme/vme_universe_dma.c
+	vme/vmeconfig.c ../../shared/vmeUniverse/bspVmeDmaList.c\
+	../shared/vme/vme_universe_dma.c
 
 vme_rel_CPPFLAGS = $(AM_CPPFLAGS)
Index: c/src/lib/libbsp/powerpc/mvme5500/README
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/README	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/README	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,4 +1,4 @@
 #
-#  $Id: README,v 1.3.1  Shuchen Kate Feng, NSLS, BNL (08/27/07)
+#  $Id: README,v 1.4.1  Shuchen Kate Feng, NSLS, BNL (03/16/2009)
 #
 
@@ -8,5 +8,5 @@
 reference README.irq 
 
-The BSP is built and tested on the 4.7.1 and 4.7.99.2 CVS RTEMS release.
+The BSP is built and tested on the 4.8.0 RTEMS release.
 
 I believe in valuable real-time programming, where technical neatness,
Index: c/src/lib/libbsp/powerpc/mvme5500/README.booting
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/README.booting	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/README.booting	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -1,7 +1,5 @@
-README.booting: written by S. Kate Feng <feng1@bnl.gov>, Aug. 28, 2007
+README.booting: written by S. Kate Feng <feng1@bnl.gov>, March 16, 2009
 
-The bootloader is adapted from Till Straumann's Generic Mini-loader,
-which he wrote originally for the SVGM powerpc board. 
-The BSP is built and tested on the 4.7 CVS RTEMS release.
+The BSP is built and tested on the  RTEMS 4.8.0 release.
 
 Booting requirement :
@@ -12,10 +10,5 @@
    (Note : EPICS needs a NTP server).
  
-2) Please copy the prebuilt RTEMS binary (e.g. misc/rtems5500-cexp.bin)
-   and perhaps others (e.g. misc/st.sys) to the /tftpboot/epics/hostname/bin/
-   directory or the TFTPBOOT one you specified in the 'tftpGet'
-   command of the boot script (as shown in the following example).
-
-3) Example of the boot script setup carried out on the MOTLoad 
+2) Example of the boot script setup carried out on the MOTLoad 
    command line : 
 
@@ -33,21 +26,12 @@
         sxx.xx.xx.xx is the server IP address)
 
-4) Other reference web sites for mvme5500 BSP:
-http://lansce.lanl.gov/EPICS/presentations/KateFeng%20RTEMS-mvme55001.ppt
+3) Other reference web sites for mvme5500 BSP:
 http://www.nsls.bnl.gov/facility/expsys/software/EPICS/
-http://www.nsls.bnl.gov/facility/expsys/software/EPICS/FAQ.txt
 
-5) When generating code (especially C++) for this system, one should
-   use at least gcc-3.2 (preferrably a copy downloaded from the RTEMS
-   site [snapshot area] )
 
-6) To reboot the RTEMS-MVME5500 (board reset), one can invoke the
+4) To reboot the RTEMS-MVME5500 (board reset), one can invoke the
    rtemsReboot() command at Cexp> prompt.
  
-7) Please reference http://www.slac.stanford.edu/~strauman/rtems
-for the source code and installation guidance of cexp, GeSys and
-other useful utilities such as telnet, nfs, and so on. 
-
-8) To get started with RTEMS/EPICS and to build development
+5) To get started with RTEMS/EPICS and to build development
 tools and BSP, I would recommend one to reference
 http://www.aps.anl.gov/epics/base/RTEMS/tutorial/
Index: c/src/lib/libbsp/powerpc/mvme5500/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/include/bsp.h	(revision e1be2b30ad3b43c28cba087614a6ebca6356445e)
+++ c/src/lib/libbsp/powerpc/mvme5500/include/bsp.h	(revision d7196bfd6696be61880fff7db8ca4de044c30748)
@@ -8,5 +8,6 @@
  *  http://www.rtems.com/license/LICENSE.
  *
- *  S. Kate Feng 2003-2007 : Modified it to support the mvme5500 BSP.
+ *  (C) S. Kate Feng 2003-2007 : Modified it to support the mvme5500 BSP.
+ *
  *
  */
@@ -23,8 +24,55 @@
 #include <bsp/vectors.h>
 
-#include <bsp/bspMvme5500.h>
+/* Board type */
+typedef enum {
+	undefined = 0,
+	MVME5500,
+	MVME6100
+} BSP_BoardTypes;
+
+BSP_BoardTypes BSP_getBoardType();
+
+/* Board type */
+typedef enum {
+	Undefined,
+	UNIVERSE2,
+	TSI148,
+} BSP_VMEchipTypes;
+
+BSP_VMEchipTypes BSP_getVMEchipType();
+
+/* The version of Discovery system controller */
+
+typedef enum {
+	notdefined, 
+	GT64260A,
+	GT64260B,	    
+	MV64360,
+} DiscoveryChipVersion;
+
+DiscoveryChipVersion BSP_getDiscoveryChipVersion();
+
+#define _256M           0x10000000
+#define _512M           0x20000000
+
+#define GT64x60_REG_BASE	0xf1000000  /* Base of GT64260 Reg Space */
+#define GT64x60_REG_SPACE_SIZE	0x10000     /* 64Kb Internal Reg Space */
+
+#define GT64x60_DEV1_BASE       0xf1100000  /* Device bank1(chip select 1) base
+                                             */
+#define GT64260_DEV1_SIZE 	0x00100000 /* Device bank size */
 
 /* fundamental addresses for this BSP (PREPxxx are from libcpu/io.h) */
-#define _IO_BASE GT64260_REG_BASE
+#define _IO_BASE GT64x60_REG_BASE
+
+#define BSP_NVRAM_BASE_ADDR     0xf1110000
+
+#define BSP_RTC_INTA_REG        0x7ff0
+#define BSP_RTC_SECOND	        0x7ff2  
+#define BSP_RTC_MINUTE	        0x7ff3
+#define BSP_RTC_HOUR	        0x7ff4  
+#define BSP_RTC_DATE	        0x7ff5
+#define BSP_RTC_INTERRUPTS      0x7ff6
+#define BSP_RTC_WATCHDOG        0x7ff7
 
 /* PCI0 Domain I/O space */
@@ -73,13 +121,10 @@
 
 /* uart.c uses out_8 instead of outb  */
-#define BSP_UART_IOBASE_COM1	GT64260_DEV1_BASE + 0x20000
-#define BSP_UART_IOBASE_COM2	GT64260_DEV1_BASE + 0x21000
+#define BSP_UART_IOBASE_COM1	GT64x60_DEV1_BASE + 0x20000
+#define BSP_UART_IOBASE_COM2	GT64x60_DEV1_BASE + 0x21000
 
 #define BSP_CONSOLE_PORT		BSP_UART_COM1  /* console */
 #define BSP_UART_BAUD_BASE		115200
 
-/*
- * Vital Board data Start using DATA RESIDUAL
- */
 /*
  * Total memory using RESIDUAL DATA
@@ -121,17 +166,24 @@
 #endif
 
-extern int
-RTEMS_BSP_NETWORK_DRIVER_ATTACH(/* struct rtems_bsdnet_ifconfig * */);
+extern int RTEMS_BSP_NETWORK_DRIVER_ATTACH();
 
-/* As per Linux, This should be in the ppc/system.h */
+#define gccMemBar() RTEMS_COMPILER_MEMORY_BARRIER()
 
+static inline void lwmemBar()
+{
+    asm volatile("lwsync":::"memory");
+}
+
+static inline void io_flush()
+{
+    asm volatile("isync":::"memory");
+}
 static inline void memBar()
 {
     asm volatile("sync":::"memory");
 }
-
 static inline void ioBar()
 {
-    asm volatile("eieio");
+    asm volatile("eieio":::"memory");
 }
 
